#include <R.h>
#include <Rmath.h>

void meanSmoothing(int *n, int *dim, double *data, double *bandwidth,
		   double *estimates, double *weights){

  double ih2[*dim];
  for (int i=0;i<*dim;i++)
    ih2[i] = 0.5 / (bandwidth[i] * bandwidth[i]);

  for (int i=0;i<*n;i++){

    double scalingCst = 0;

    for (int j=0;j<*n;j++){
      double kernel = 0;

      for (int d=0;d<*dim;d++)
	kernel += (data[j + d * *n] - data[i + d * *n]) * (data[j + d * *n] - data[i + d * *n]) * ih2[d];

      kernel = exp(-kernel);
      weights[i + j * *n] = kernel;

      for (int d=0;d<*dim;d++)
	estimates[i + d * *n] += data[j + d * *n] * kernel;

      scalingCst += kernel;
    }

    for (int d=0;d<*dim;d++)
      estimates[i + d * *n] /= scalingCst;
  }
}

void meanSmoothing2(int *n, int *dim, double *data, double *data2, double *bandwidth,
		   double *estimates, double *weights){

  double ih2 = 0.5 * *dim / (*bandwidth * *bandwidth);

  for (int i=0;i<*n;i++){

    double scalingCst = 0;

    for (int j=0;j<*n;j++){
      double kernel = 0;

      kernel += (data2[j] - data2[i]) * (data2[j] - data2[i]) * ih2;
      kernel = exp(-kernel);
      weights[i + j * *n] = kernel;

      for (int d=0;d<*dim;d++)
	estimates[i + d * *n] += data[j + d * *n] * kernel;

      scalingCst += kernel;
    }

    for (int d=0;d<*dim;d++)
      estimates[i + d * *n] /= scalingCst;
  }
}

